/*
 * Copyright (c) 1999 Simon Tatham
 * Copyright (c) 1999 Ben Harris
 * All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/*------------------------------------------------------------------------------------------
 * set ts=4 sw=4
 *
 *       Support serial port for PuTTY(0.53b).
 *
 *       Module Name    : com.c
 *       Made By        : beta@nsum.com
 *
 *       History
 *       	2003. 12. 03		for win32 (poor coding)
 *
 *       	߰ߵ .
 *
 *       1. handle  Ѱ closed. ޸  ,  ϵ...
 *          (  ϰ Ѿ ִ κ  ֽϴ. --;)
 *
 * 			== Ʒ  100%  Ҽ . ==
 * 			{ 
 *       	 Saved Sessions  com Ѱ load ѳ  Category  ޴ 
 *       	ϳغ. (logging ޴) ׸ open Ұ, WriteFile  Ѵ. 
 *			GetLastError() = 6 The handle is invalid.  ERROR_INVALID_HANDLE 
 *			}
 *       	
 *       	׷  ޴ ϰ Ŭϸ  .
 *       	 𸣰. ũũ..
 *
 *       	  մκ ̻ϲ ϰ, , 𸣰.
 *       	WINDOW.C  PROTO_COM ̱⶧ ϰ Ѿ  ãƺƾ ҵ.
 *
 *       2. PuTTY ȭ鿡½(ReadFile) ٸ  focus  ̵ɶ, PuTTY ȭ
 *       	̵Ǿ .
 *
 *  ** ǻ **
 *           ڵ  windows SERIAL programming  ó, ڵ忡  
 *          ȵǾ . --;  ùٸ  ڵ ƴҼ .
 *           ҽ м ʰ, ۾Ƿ, Ȥ ļ ȵɰ  . ;)
 *          ũƼѰ(α׸ ų ϴ) ҷ  ׽Ʈ Ͻñ
 *          ٶ.
 *            ڼ ǽź  Ͻñ ٶ. ũ.. 
 *
 *           ϴµ  ( ߽ ַ ...)  尩ϴ. --;
 ------------------------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

#include "putty.h"

/*{{{*/
DWORD  WINAPI		com_thread_poll_port( LPVOID lpParam ) ;
static int			com_closing( Plug plug, const char *error_msg, int error_code, int calling_back ) ;
static int			com_closing_ext( void *handle, const char *error_msg ) ;
int					com_receive( void *handle, int urgent, char *data, int len ) ;
static void			com_sent( Plug plug, int bufsize ) ;

static const char *	com_init( void *, void **, Config *, char *, int, char **, int ) ;
static void 		com_free( void * ) ;
static void 		com_reconfig( void *, Config * ) ;
static int 			com_send( void *, char *, int ) ;
static int 			com_sendbuffer( void * ) ;
static void 		com_size( void *, int, int ) ;
static void			com_special( void *, Telnet_Special ) ;
static const struct telnet_special *com_get_specials( void *handle ) ;
static				Socket com_socket( void * ) ;
static int			com_exitcode( void * ) ;
static int			com_sendok( void * ) ;
static int			com_ldisc( void *, int ) ;
static void			com_provide_ldisc( void *, void * ) ;
static void			com_provide_logctx( void *, void * ) ;
static void			com_unthrottle( void *, int ) ;
/*}}}*/

static void *backhandle ;	/* for com_thread_poll_port */

typedef struct com_tag {
	const struct plug_function_table *fn ;
	/* the above field _must_ be first in the structure */

	HANDLE  handle	;
	DCB	    dcb		;
	COMMTIMEOUTS timeouts ;

	HANDLE  	th_handle ;
	OVERLAPPED	roverlab  ;
	OVERLAPPED  woverlab  ;

	int echoing, editing;

	int 	isconnected ;
	int 	isreading 	;
	int 	bufsize		;
	void  * frontend	;
} *Com ;

#if 0
DWORD WINAPI com_thread_poll_port( LPVOID lpParam )/*{{{*/
{
	Com com  = backhandle ;
	DWORD	   eventmask  ;

	memset( &com->roverlab, 0, sizeof(OVERLAPPED) ) ;

	if( !(com->roverlab.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL )) )
		return -1 ;
	if( ! SetCommMask( com->handle, EV_RXCHAR ) )
		return -1 ;

	while( com->isconnected )
	{
		eventmask = 0 ;
		WaitCommEvent( com->handle, &eventmask, NULL ) ;

		if( (eventmask & EV_RXCHAR) == EV_RXCHAR )
			PostMessage( com->frontend, WM_COMEVENT, 0, 0 ) ;
	}

	CloseHandle( com->roverlab.hEvent ) ;
	com->th_handle = NULL ;

	return 0 ;
}/*}}}*/
#endif

DWORD WINAPI com_thread_poll_port( LPVOID lpParam )/*{{{*/
{
	Com com  = (Com) backhandle ;
	DWORD	   eventmask  ;

	if( ! SetCommMask( com->handle, EV_RXCHAR ) )
		return -1 ;

	while( com->isconnected )
	{
		eventmask = 0 ;
		com->isreading = FALSE ;
		if( !WaitCommEvent( com->handle, &eventmask, NULL ) )
			MessageBox(NULL, "fail to WaitCommEvent in com_thread_poll_port", "DEBUG", MB_OK);

		com->isreading = TRUE  ;
		if( (eventmask & EV_RXCHAR) == EV_RXCHAR )
		{
			int len ;
			char buf[20480] ;

			if (!ReadFile(com->handle, buf, sizeof(buf), &len, &com->roverlab))
			{
				if (GetLastError()==ERROR_IO_PENDING)
				{
					if (!GetOverlappedResult(com->handle, &com->roverlab, &len, TRUE))
						MessageBox(NULL, "read error in com_thread_poll_port", "DEBUG", MB_OK);
				}
				else
					com->isconnected = FALSE ;
			}

			if(len > 0)
				from_backend(com->frontend, 1, buf, len) ;
		}
	}

	from_backend(com->frontend, 1, "Connection closed....", 21) ;

	return 0 ;
}/*}}}*/

static int com_closing( Plug plug, const char *error_msg, int error_code, int calling_back )/*{{{*/
{
#if 0
	Com com = (Com) plug;

	com->isconnected = FALSE ;
	from_backend(com->frontend, 1, "Connection closed....", 21) ;

	if (com->th_handle) {
		 CloseHandle(com->th_handle);
		 com->th_handle = NULL;
	}

    if (com->handle) {
        CloseHandle(com->handle);
        com->handle = NULL;
    }
    if (error_msg) {
	/* A socket error has occurred. */
	logevent(com->frontend, error_msg) ;
	connection_fatal(com->frontend, "%s", error_msg);
    }				       /* Otherwise, the remote side closed the connection normally. */
#endif
	MessageBox(NULL, "called com_closing", "DEBUG", MB_OK);
    return 0;

}/*}}}*/

static int com_closing_ext(void *handle, const char *error_msg )/*{{{*/
{
	Com com = (Com) handle;

	com->isconnected = FALSE ;
	from_backend(com->frontend, 1, "Connection closed....", 21) ;

	if (com->th_handle) {
		 CloseHandle(com->th_handle);
		 com->th_handle = NULL;
	}

    if (com->handle) {
        CloseHandle(com->handle);
        com->handle = NULL;
    }
    if (error_msg) {
	/* A socket error has occurred. */
	logevent(com->frontend, error_msg) ;
	connection_fatal(com->frontend, "%s", error_msg);
    }				       /* Otherwise, the remote side closed the connection normally. */
    return 0;

}/*}}}*/

int	com_receive( void *handle, int urgent, char *data, int len )/*{{{*/
{
	return 1;
}/*}}}*/

static void com_sent( Plug plug, int bufsize )/*{{{*/
{
	Com com = (Com) plug ;
	com->bufsize = bufsize ;
}/*}}}*/


static const char *com_init(void *frontend_handle, void **backend_handle, Config *cfg, char *host, int port, char **realhost, int nodelay) /*{{{*/
{
	static const struct plug_function_table fn_table = {
	com_closing,
	com_receive,
	com_sent
	};

	Com com ;

	com 	= snew( struct com_tag ) ;
	com->fn = &fn_table 	;
	com->handle		= NULL	;
	if(cfg->localecho != AUTO )
		com->echoing	= cfg->localecho ;
	if(cfg->localedit != AUTO )
		com->editing	= cfg->localedit ;
	com->isconnected= 0		;

	*backend_handle = com	;

	com->frontend	= frontend_handle ;

	backhandle 		= com	;
	/*
	 * verify host, port (com port control, ex "38400,8,N,1")
	 */
	{
		char  dev_name[10]	;	
		DWORD baudrate		;
		DWORD bytesize		;
		DWORD parity		;
		DWORD stopbits		;

		if( port < 1 )
			return "Opening failed! (invalid port)" ;
		
		_snprintf(dev_name, 10-1, "\\\\.\\COM%d", port ) ;
		com->handle = CreateFile( dev_name, 
								  GENERIC_READ | GENERIC_WRITE,
								  0, // Exclusive access
								  NULL,
								  OPEN_EXISTING,
								  FILE_FLAG_OVERLAPPED,
								  NULL ) ;
		if( com->handle == INVALID_HANDLE_VALUE )
			return "Opening failed! -2" ;

		if( !GetCommState( com->handle, &com->dcb ))
			return "GetCommState in com_init" ;

		{
			sscanf(host, "%d,%d,%C,%d",  &baudrate, &bytesize, &parity, &stopbits );

			if(!(	baudrate == CBR_110		|| baudrate == CBR_19200   ||
					baudrate ==	CBR_300 	|| baudrate == CBR_38400   ||
					baudrate ==	CBR_600 	|| baudrate == CBR_56000   ||
					baudrate == CBR_1200 	|| baudrate == CBR_57600   ||
					baudrate ==	CBR_2400 	|| baudrate == CBR_115200  ||
					baudrate ==	CBR_4800 	|| baudrate == CBR_128000  ||
					baudrate ==	CBR_9600 	|| baudrate == CBR_256000  ||
					baudrate ==	CBR_14400 ) )
				return "invalid baudrate.(ex, 110, 300, .... 128000, 256000)" ;

			if(!(bytesize == 5 || bytesize == 6 ||
				 bytesize == 7 || bytesize == 8  ))
				return "invalid bytesize.(ex, 5,6,7,8)" ;

			switch(parity)
			{
				case 'E':
				case 'e': parity = 2; break ;
				case 'M':
				case 'm': parity = 3; break ;
				case 'N':
				case 'n': parity = 0; break ;
				case 'O':
				case 'o': parity = 1; break ;
				case 'S':
				case 's': parity = 4; break ;
				default:
					return "invalid parity.(ex, E, M, N, O, S)" ;
			}

			switch(stopbits)
			{
				case 1:	stopbits = ONESTOPBIT;  break ;
				case 2:	stopbits = TWOSTOPBITS; break ;
				default:
					return "invalid stopbits.(ex, 1, 2)" ;
			}

			com->dcb.BaudRate	= baudrate	;
			com->dcb.ByteSize	= (BYTE)bytesize	;
			com->dcb.Parity		= (BYTE)parity	;
			com->dcb.StopBits	= (BYTE)stopbits	;
		}

		if( !SetCommState( com->handle, &com->dcb ))
			return "invalid host (ex, 38400,8,N,1)" ;

		com->timeouts.ReadIntervalTimeout		= 10 ;
		com->timeouts.ReadTotalTimeoutMultiplier=  0 ;
		com->timeouts.ReadTotalTimeoutConstant	= 20 ;
		com->timeouts.WriteTotalTimeoutMultiplier= 0 ;
		com->timeouts.WriteTotalTimeoutConstant	=  0 ;

		if( !SetCommTimeouts( com->handle, &com->timeouts ))
			return "SetCommTimeouts in com_init" ;

		PurgeComm( com->handle, PURGE_RXCLEAR|PURGE_RXABORT ) ;

		com->isconnected = TRUE ;
		com->th_handle   = CreateThread( NULL, 0, com_thread_poll_port, NULL, 0, NULL) ;
	}

	return NULL;
}/*}}}*/

static void com_free(void *handle)/*{{{*/
{
	Com com = (Com) handle;

	MessageBox(NULL, "called com_free", "DEBUG", MB_OK);

	com->isconnected = FALSE ;

	if (com->th_handle)
		CloseHandle(com->th_handle) ;

	if (com->handle)
		CloseHandle(com->handle) ;

	sfree(com);
}/*}}}*/

static void com_reconfig(void *handle, Config *cfg) /*{{{*/
{
	/* Do nothing! */
	return ;
}/*}}}*/

static int com_send(void *handle, char *buf, int len) /*{{{*/
{
	Com com = (Com) handle ;

	if (com->handle == NULL || com->isconnected == FALSE )
		return 0;

	com->bufsize = 0 ;

	/* if (com->isreading == TRUE)	return 0 ; , ۸ؾҵ.*/

	if(! WriteFile( com->handle, buf, len, &com->bufsize, &com->woverlab ))
	{
		if (GetLastError() == ERROR_IO_PENDING )
		{
			if (!GetOverlappedResult( com->handle, &com->woverlab, &com->bufsize, TRUE))
				MessageBox(NULL, "read error in com_send", "DEBUG", MB_OK);
		}
		else
			com->isconnected = FALSE ;
	}

	return com->bufsize ;
}/*}}}*/

static int com_sendbuffer(void *handle) /*{{{*/
{
	Com com = (Com) handle ;
	return com->bufsize ;
}/*}}}*/

static void com_size(void *handle, int width, int height) /*{{{*/
{
    return;
}/*}}}*/

static void com_special(void *handle, Telnet_Special code) /*{{{*/
{
	/* Do nothing! */
	return ;
}/*}}}*/

static const struct telnet_special *com_get_specials (void *handle) /*{{{*/
{
	return NULL;
}/*}}}*/

static Socket com_socket(void *handle) /*{{{*/
{
	return NULL;
}/*}}}*/

static int com_exitcode(void *handle) /*{{{*/
{
	Com com = (Com) handle ;

	if (com->handle != NULL)
		return -1 ;
	else
		return 0 ;
}/*}}}*/

static int com_sendok(void *handle) /*{{{*/
{
	return 1;
}/*}}}*/

static void com_unthrottle(void *handle, int backlog) /*{{{*/
{
	/* Do nothing! */
	return ;
}/*}}}*/

static int com_ldisc(void *handle, int option) /*{{{*/
{
    Com com = (Com) handle;

    if (option == LD_ECHO)
		return com->echoing;

    if (option == LD_EDIT)
		return com->editing;

    return 0;
}/*}}}*/

static void com_provide_ldisc (void *handle, void *ldisc) /*{{{*/
{
	/* This is a stub. */
}/*}}}*/

static void com_provide_logctx(void *handle, void *logctx) /*{{{*/
{
	/* This is a stub. */
}/*}}}*/

Backend com_backend = {/*{{{*/
	com_init,
	com_free,
	com_reconfig,
	com_send,
	com_sendbuffer,
	com_size,
	com_special,
	com_get_specials,
	com_socket,
	com_exitcode,
	com_sendok,
	com_ldisc,
	com_provide_ldisc,
	com_provide_logctx,
	com_unthrottle,
	1
};/*}}}*/
